/*
 * File: waijung_hwdrvlib.c
 *
 * Created with Waijung Blockset
 *
 * Real-Time Workshop code generated for Simulink model untitled.
 *
 * Model version                        : 1.3
 * Real-Time Workshop file version      : 7.6  (R2010b)  03-Aug-2010
 * Real-Time Workshop file generated on : Mon Aug 15 14:30:25 2016
 * TLC version                          : 7.6 (Jul 13 2010)
 * C/C++ source code generated on       : Mon Aug 15 14:30:26 2016
 *
 * Target selection: stm32f4.tlc
 * Embedded hardware selection: ARM Compatible->Cortex - M4
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "waijung_hwdrvlib.h"

/* ########################################################################
 * Name: <S1>/UART Tx
 * Id: EnabledSubsystemUARTTx
 * ########################################################################
 */

/* Enable UART-DMA module */
void enable_EnabledSubsystemUARTTx(void)
{
}

/* ########################################################################
 * Name: <S1>/Digital Output
 * Id: EnabledSubsystemDigitalOutput
 * ########################################################################
 */
void enable_EnabledSubsystemDigitalOutput(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOF, ENABLE);

  /* Configure PF in output Push Pull mode for EnabledSubsystemDigitalOutput Block*/
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;/* Waijung 14.xx */
  GPIO_Init(GPIOF, &GPIO_InitStructure);
}

/* ########################################################################
 * Name: <S2>/Regular ADC
 * Id: RegularADC
 * ########################################################################
 */
ADC_InitTypeDef RegularADC_ADC_InitStructure;
ADC_CommonInitTypeDef RegularADC_ADC_CommonInitStructure;
DMA_InitTypeDef RegularADC_DMA_InitStructure;

/* RegularADC */
uint16_t RegularADC_ConvertedValue[1];
void enable_RegularADC(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  /* Enable ADCx, DMA and GPIO clocks ****************************************/
  /* ADC1 */
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA2, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);

  /* Configure ADCx using channel pins as analog input ******************************/
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL ;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;

  /* ADC pin B0*/
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
  GPIO_Init(GPIOB, &GPIO_InitStructure);

  /* DMA2 Stream channel configuration **************************************/
  RegularADC_DMA_InitStructure.DMA_Channel = RegularADC_DMA_CHANNEL;
  RegularADC_DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralToMemory;
  RegularADC_DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  RegularADC_DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
  RegularADC_DMA_InitStructure.DMA_PeripheralDataSize =
    DMA_PeripheralDataSize_HalfWord;
  RegularADC_DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
  RegularADC_DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
  RegularADC_DMA_InitStructure.DMA_Priority = DMA_Priority_High;
  RegularADC_DMA_InitStructure.DMA_FIFOMode = DMA_FIFOMode_Disable;
  RegularADC_DMA_InitStructure.DMA_FIFOThreshold = DMA_FIFOThreshold_HalfFull;
  RegularADC_DMA_InitStructure.DMA_MemoryBurst = DMA_MemoryBurst_Single;
  RegularADC_DMA_InitStructure.DMA_PeripheralBurst = DMA_PeripheralBurst_Single;
  RegularADC_DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)
    RegularADC_ADC_DR_ADDRESS;
  RegularADC_DMA_InitStructure.DMA_Memory0BaseAddr = (uint32_t)&
    RegularADC_ConvertedValue;
  RegularADC_DMA_InitStructure.DMA_BufferSize = 1;

  /* ADC Common Init **********************************************************/
  RegularADC_ADC_CommonInitStructure.ADC_Mode = ADC_Mode_Independent;
  RegularADC_ADC_CommonInitStructure.ADC_Prescaler = ADC_Prescaler_Div2;
  RegularADC_ADC_CommonInitStructure.ADC_DMAAccessMode =
    ADC_DMAAccessMode_Disabled;
  RegularADC_ADC_CommonInitStructure.ADC_TwoSamplingDelay =
    ADC_TwoSamplingDelay_5Cycles;

  /* ADCx Init ****************************************************************/
  RegularADC_ADC_InitStructure.ADC_Resolution = ADC_Resolution_12b;
  RegularADC_ADC_InitStructure.ADC_ScanConvMode = ENABLE;
  RegularADC_ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;
  RegularADC_ADC_InitStructure.ADC_ExternalTrigConvEdge =
    ADC_ExternalTrigConvEdge_None;
  RegularADC_ADC_InitStructure.ADC_ExternalTrigConv =
    ADC_ExternalTrigConv_Ext_IT11;     // avoid assert_fail
  RegularADC_ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
  RegularADC_ADC_InitStructure.ADC_NbrOfConversion = 1;
}

void RegularADCStartConversion(void)
{
  /* DMA */
  DMA_DeInit(RegularADC_DMA_STREAM);
  DMA_Init(RegularADC_DMA_STREAM, &RegularADC_DMA_InitStructure);
  DMA_Cmd(RegularADC_DMA_STREAM, ENABLE);

  /* ADC Common */
  ADC_CommonInit(&RegularADC_ADC_CommonInitStructure);

  /* ADC */
  ADC_Init(ADC1, &RegularADC_ADC_InitStructure);

  /* ADCx regular channel1 configuration *************************************/
  ADC_RegularChannelConfig(ADC1, ADC_Channel_8, 1, ADC_SampleTime_3Cycles);

  /* Enable DMA request after last transfer (Single-ADC mode) */
  ADC_DMARequestAfterLastTransferCmd(ADC1, ENABLE);

  /* Enable ADC1 DMA */
  ADC_DMACmd(ADC1, ENABLE);

  /* Enable ADC1 */
  ADC_Cmd(ADC1, ENABLE);

  /* Start ADC Software Conversion */
  ADC_SoftwareStartConv(ADC1);

  /* Wait for ADA1-DMA transfer complete */
  while (!DMA_GetFlagStatus(RegularADC_DMA_STREAM, RegularADC_DMA_TC_FLAG)) ;

  /* Clear */
  DMA_ClearFlag(RegularADC_DMA_STREAM, RegularADC_DMA_TC_FLAG);
}

void disable_RegularADC(void)
{
}

/* ########################################################################
 * Name: <S2>/UART Tx
 * Id: EnabledSubsystem1UARTTx
 * ########################################################################
 */

/* Enable UART-DMA module */
void enable_EnabledSubsystem1UARTTx(void)
{
}

/* ########################################################################
 * Name: <S3>/UART Tx
 * Id: EnabledSubsystem2UARTTx
 * ########################################################################
 */

/* Enable UART-DMA module */
void enable_EnabledSubsystem2UARTTx(void)
{
}

/* ########################################################################
 * Name: <Root>/UART Rx
 * Id: UARTRx
 * ########################################################################
 */

/* Data read structure */
UARTRX_BUFFER_READ_STRUCT UARTRx_read_structure = { 0, 0, (uint8_t *)0 };

/* Data */
uint32_t UARTRx_data0 = 0;

/* Non-Blocking */
uint8_t UARTRx_Receive(uint8_t *buffer, uint16_t size)
{
  uint8_T ready = 0;
  const char terminator[2] = { 13, 10 };/* Terminator */

  /* Rx Non-Blocking */
  if (UART1_ReadLine(&UARTRx_read_structure, terminator, 2, buffer, size) > 0) {
    ready = (uint8_t)(sscanf((const char*)buffer,"LED1=%u\r\n" ,&UARTRx_data0 ) ==
                      1);
  }

  return ready;
}

/* Enable UART-DMA module */
void enable_UARTRx(void)
{
}

/* ########################################################################
 * Name: <Root>/UART Rx1
 * Id: UARTRx1
 * ########################################################################
 */

/* Data read structure */
UARTRX_BUFFER_READ_STRUCT UARTRx1_read_structure = { 0, 0, (uint8_t *)0 };

/* Data */
uint32_t UARTRx1_data0 = 0;

/* Non-Blocking */
uint8_t UARTRx1_Receive(uint8_t *buffer, uint16_t size)
{
  uint8_T ready = 0;
  const char terminator[2] = { 13, 10 };/* Terminator */

  /* Rx Non-Blocking */
  if (UART1_ReadLine(&UARTRx1_read_structure, terminator, 2, buffer, size) > 0)
  {
    ready = (uint8_t)(sscanf((const char*)buffer,"ADC%u?\r\n" ,&UARTRx1_data0 ) ==
                      1);
  }

  return ready;
}

/* Enable UART-DMA module */
void enable_UARTRx1(void)
{
}

/* ########################################################################
 * Name: <Root>/UART Rx2
 * Id: UARTRx2
 * ########################################################################
 */

/* Data read structure */
UARTRX_BUFFER_READ_STRUCT UARTRx2_read_structure = { 0, 0, (uint8_t *)0 };

/* Data */
float UARTRx2_data0 = 0;

/* Non-Blocking */
uint8_t UARTRx2_Receive(uint8_t *buffer, uint16_t size)
{
  uint8_T ready = 0;
  const char terminator[2] = { 13, 10 };/* Terminator */

  /* Rx Non-Blocking */
  if (UART1_ReadLine(&UARTRx2_read_structure, terminator, 2, buffer, size) > 0)
  {
    ready = (uint8_t)(sscanf((const char*)buffer,"Input %f\r\n" ,&UARTRx2_data0 )
                      == 1);
  }

  return ready;
}

/* Enable UART-DMA module */
void enable_UARTRx2(void)
{
}

/* ########################################################################
 * Name: <Root>/UART Setup
 * Id: UARTSetup
 * ########################################################################
 */

/* Tx buffer */
uint8_t UART1_Tx_Buffer[UTX1_BUFFER_SIZE];
UART_TX_STATE UARTSetup_Tx_State;

/* Rx buffer */
uint8_t UART1_Rx_Buffer[URX1_BUFFER_SIZE];
uint8_t UART1_Temp_Buffer[URX1_BUFFER_SIZE];

/* DMA Init struct */
DMA_InitTypeDef UARTSetup_DMA_Init;

/* Init buffer read */
void UART1_RestoreBytes(UARTRX_BUFFER_READ_STRUCT *read_struct, uint16_t count)
{
  uint16_t roll_count = count;

  /* Remove overflow buffer */
  while (roll_count > URX1_BUFFER_SIZE)
    roll_count -= URX1_BUFFER_SIZE;

  /* Return bytes back into buffer */
  if (roll_count > read_struct->index) {
    read_struct->index = URX1_BUFFER_SIZE - roll_count + read_struct->index;
  } else {
    read_struct->index -= roll_count;
  }
}

/* Read buffer from DMA
 ** Return value: Number of bytes vaiable.
 */
void UART1_Read(UARTRX_BUFFER_READ_STRUCT *read_struct)
{
  __IO uint16_t dma_curr_ndtr;
  __IO uint16_t dma_curr_index;
  uint16_t data_index = 0;
  uint16_t data_count = 0;

  /* Get current NDTR */
  if ((dma_curr_ndtr = DMA2_Stream2->NDTR) == 0) {/* Not initialize or turn-around state*/
    read_struct->count = 0;
    return;
  }

  /* Get current data indexs */
  dma_curr_index = URX1_BUFFER_SIZE - dma_curr_ndtr;
  if (read_struct->index < dma_curr_index) {
    /* Data is available */
    data_index = read_struct->index;
    data_count = dma_curr_index - read_struct->index;
    read_struct->index += data_count;
    read_struct->index &= (URX1_BUFFER_SIZE-1);
  } else if (read_struct->index > dma_curr_index) {
    /* Data is available with overlap */
    data_index = read_struct->index;
    data_count = URX1_BUFFER_SIZE-read_struct->index;
    read_struct->index = 0;
  } else {                             /* No new data */
  }

  /* Return the reading */
  if (data_count > 0) {
    read_struct->buffer = &UART1_Rx_Buffer[data_index];
    read_struct->count = data_count;
  } else {
    read_struct->count = 0;
  }
}

void UART1_ReadEx(UARTRX_BUFFER_READ_STRUCT *read_struct, uint8_t *buffer,
                  uint16_t buffer_size, uint16_t*reading_count)
{
  uint16_t bytes_to_read, data_read_index;
  bytes_to_read = buffer_size;         /* Tracking count of data readings */
  data_read_index = 0;                 /* Increment buffer index */
  do {
    UART1_Read(read_struct);
    if (read_struct->count <= bytes_to_read) {
      memcpy(&buffer[data_read_index], read_struct->buffer, read_struct->count);
      data_read_index += read_struct->count;
      bytes_to_read -= read_struct->count;
    } else {
      /* Return some byte back to buffer */
      //read_struct->index -= (read_struct->count - bytes_to_read);
      UART1_RestoreBytes(read_struct, (read_struct->count - bytes_to_read));/* Fixed: Waijung 14.05a */

      /* Return reading data */
      memcpy(&buffer[data_read_index], read_struct->buffer, bytes_to_read);
      bytes_to_read = 0;
    }
  } while ((bytes_to_read > 0) && (read_struct->count > 0));

  /* Number of reading bytes */
  *reading_count = buffer_size - bytes_to_read;
}

/* Read Ascii packet
 * Return char count, exclude NULL
 * Terminator: "\n", "\r", "\r\n"
 */
uint16_t UART1_ReadLine(UARTRX_BUFFER_READ_STRUCT *read_struct, const char
  *terminator, uint16_t terminator_count, uint8_t *buffer, uint16_t buffer_size)
{
  uint16_t count, packet_len = 0, receive_count = 0;
  uint16_t i;
  uint16_t terminator_found = 0;

  /* Determine maximum number of bytes to read */
  count = buffer_size - 1;
  if (count >= URX1_BUFFER_SIZE)
    count = URX1_BUFFER_SIZE-1;

  /* Ignore terminator is invalid */
  if (terminator_count < 1)
    return 0;

  /* Read packet */
  do {
    terminator_found = 0;
    UART1_Read(read_struct);           /* Check DMA buffer */
    receive_count += read_struct->count;/* Total number of data received */

    /* Search terminator */
    i = 0;
    while (!(terminator_found == terminator_count) && (i < read_struct->count))
    {
      if (read_struct->buffer[i] == (uint8_t)terminator[terminator_found/*terminator_count - 1*/
          ])
        terminator_found ++;
      i++;
    }

    packet_len += i;
    if (terminator_found == terminator_count) {
      terminator_found = 0;

      /* Roll-back buffer index */
      if ((packet_len > count) || (packet_len < terminator_count)) {/* Packet count is invalid, drop it */
        UART1_RestoreBytes(read_struct, (receive_count-packet_len));

        /* Reset */
        packet_len = 0;
        receive_count = 0;
      } else {
        UART1_RestoreBytes(read_struct, receive_count);

        /* Load data into buffer */
        UART1_ReadEx(read_struct, buffer, packet_len, &i);
        buffer[packet_len] = '\0';     /* Append NULL */

        /* Validate terminator */
        if (!strncmp((char *)&buffer[packet_len-terminator_count], terminator,
                     terminator_count)) {
          return packet_len;           /* packet reading success, return number of received bytes */
        } else {
          /* Invalid terminator */
          packet_len = 0;
          receive_count = 0;
        }
      }
    }
  } while (read_struct->count > 0);

  /* Could not find the packet terminator, reset reading struct to its original position */
  if (receive_count > 0) {
    UART1_RestoreBytes(read_struct, receive_count);
  }

  /* No byte receive */
  return 0;
}

/* Read Binary packet
 * 0: Not ready, 1: Data is ready
 */
uint8_t UART1_ReadBinary(UARTRX_BUFFER_READ_STRUCT *read_struct, const char
  *header, uint16_t header_count, const char *terminator, uint16_t
  terminator_count, uint8_t *buffer, uint16_t data_count)
{
  uint16_t receive_count = 0, drop_count = 0, binary_state = 0, binary_index = 0;
  uint16_t i;
  do {
    UART1_Read(read_struct);           /* Check DMA buffer */
    receive_count += read_struct->count;/* Total number of data received */

    /* Binary packet processing */
    for (i=0; i<read_struct->count; i++) {
      switch ( binary_state ) {
       case 0:                         /* Search for header */
        if (binary_index < header_count) {
          if (read_struct->buffer[i] == header[binary_index]) {
            binary_index ++;
          } else {
            binary_index = 0;
            drop_count = receive_count - (read_struct->count - i - 1);/* Drop packet */
          }
          break;
        } else {                       /* Change to DATA state */
          binary_index = 0;
          binary_state ++;
        }

       case 1:                         /* Wait for data */
        /* Wait for DATA */
        if (binary_index < data_count) {
          buffer[binary_index] = read_struct->buffer[i];
          binary_index ++;

          /* Check if ready (No terminator) */
          if ((binary_index >= data_count) && (terminator_count == 0)) {
            UART1_RestoreBytes(read_struct, (read_struct->count - i - 1));/* Restore some bytes */
            return 1;                  /* Return success status */
          }
          break;
        } else {                       /* Change to Terminator state */
          binary_index = 0;
          binary_state ++;
        }

       case 2:                         /* Scan for terminator */
        if (binary_index < terminator_count) {
          if (read_struct->buffer[i] == terminator[binary_index]) {
            binary_index ++;
          } else {
            binary_state = 0;
            binary_index = 0;
            drop_count = receive_count - (read_struct->count - i - 1);/* Drop packet */
          }
        }

        if (binary_index >= terminator_count) {/* Success */
          /* Restore some bytes */
          UART1_RestoreBytes(read_struct, (read_struct->count - i - 1));
          return 1;                    /* Return success status */
        }
        break;
      }
    }
  } while (read_struct->count > 0);

  /* Restore bytes */
  UART1_RestoreBytes(read_struct, (receive_count - drop_count));
  return 0;
}

/* Wait for DMA transfer to completion */
UART_TX_STATE UART1_FlushTxBuffer(void)
{
  if (UARTSetup_Tx_State != txIdle) {
    /* Chehck last DMA transmit */
    while ((DMA_GetFlagStatus(DMA2_Stream7, DMA_FLAG_TCIF7) == RESET)
           || (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET)) {
    }

    /* Clear DMA Streams flags */
    DMA_ClearFlag(DMA2_Stream7, DMA_FLAG_HTIF7 | DMA_FLAG_TCIF7);

    /* Disable the DMA Streams */
    DMA_Cmd(DMA2_Stream7, DISABLE);

    /* Disable the USART Tx DMA request */
    USART_DMACmd(USART1, USART_DMAReq_Tx, DISABLE);

    /* Update state */
    UARTSetup_Tx_State = txIdle;
  }

  return UARTSetup_Tx_State;
}

/* Write to DMA buffer */
void UART1_Write(uint8_t* data, uint16_t count)
{
  if (count > 0) {
    /* Wait for Tx state to idle */
    UART1_FlushTxBuffer();

    /* Setup */
    memcpy(UART1_Tx_Buffer, data, count);

    /* Update */
    UART1_TxUpdate(count);
  }
}

/* Update transmit buffer */
void UART1_TxUpdate(uint16_t count)
{
  if (count > 0) {
    /* Wait for Tx state to idle */
    UART1_FlushTxBuffer();
    UARTSetup_DMA_Init.DMA_BufferSize = (uint16_t)count;
    DMA_Init(DMA2_Stream7, &UARTSetup_DMA_Init);

    /* Enable */
    USART_DMACmd(USART1, USART_DMAReq_Tx, ENABLE);
    USART_ClearFlag(USART1, USART_FLAG_TC);
    DMA_Cmd(DMA2_Stream7, ENABLE);

    /* Tx is busy */
    UARTSetup_Tx_State = txBusy;
  }
}

/* Enable UART-DMA module */
void enable_UARTSetup(void)
{
  USART_InitTypeDef USART_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;

  /* Enable GPIO clock */
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);

  /* Enable UART clock */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);

  /* Enable the DMA clock */
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA2, ENABLE);

  /* Connect PXx to USARTx_Tx*/
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource6, GPIO_AF_USART1);

  /* Connect PXx to USARTx_Rx*/
  GPIO_PinAFConfig(GPIOB, GPIO_PinSource7, GPIO_AF_USART1);

  /* Configure USART pin as alternate function  */
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;

  /* Configure USART Tx */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
  GPIO_Init(GPIOB, &GPIO_InitStructure);

  /* Configure USART Rx */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
  GPIO_Init(GPIOB, &GPIO_InitStructure);

  /* USART Configuration */
  USART_InitStructure.USART_BaudRate = 115200;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

  /* Over sampling x8 */
  USART_OverSampling8Cmd(USART1, ENABLE);

  /* USART configuration */
  USART_Init(USART1, &USART_InitStructure);

  /* Enable USART */
  USART_Cmd(USART1, ENABLE);

  /* DMA init struct configuration */
  UARTSetup_DMA_Init.DMA_PeripheralBaseAddr = (uint32_t)(&USART1->DR);
  UARTSetup_DMA_Init.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  UARTSetup_DMA_Init.DMA_MemoryInc = DMA_MemoryInc_Enable;
  UARTSetup_DMA_Init.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
  UARTSetup_DMA_Init.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
  UARTSetup_DMA_Init.DMA_FIFOMode = DMA_FIFOMode_Disable;
  UARTSetup_DMA_Init.DMA_FIFOThreshold = DMA_FIFOThreshold_Full;
  UARTSetup_DMA_Init.DMA_MemoryBurst = DMA_MemoryBurst_Single;
  UARTSetup_DMA_Init.DMA_PeripheralBurst = DMA_PeripheralBurst_Single;

  /* Configure DMA controller to manage RX DMA request */
  UARTSetup_DMA_Init.DMA_Channel = DMA_Channel_4;
  UARTSetup_DMA_Init.DMA_Memory0BaseAddr = (uint32_t)UART1_Rx_Buffer;
  UARTSetup_DMA_Init.DMA_DIR = DMA_DIR_PeripheralToMemory;
  UARTSetup_DMA_Init.DMA_BufferSize = (uint16_t)URX1_BUFFER_SIZE;
  UARTSetup_DMA_Init.DMA_Mode = DMA_Mode_Circular;
  UARTSetup_DMA_Init.DMA_Priority = DMA_Priority_VeryHigh;
  DMA_Init(DMA2_Stream2, &UARTSetup_DMA_Init);

  /* Enable the USART Rx DMA requests */
  USART_DMACmd(USART1, USART_DMAReq_Rx , ENABLE);

  /* Enable the DMA Stream */
  DMA_Cmd(DMA2_Stream2, ENABLE);

  /* Configure DMA controller to manage TX DMA request */
  UARTSetup_DMA_Init.DMA_Channel = DMA_Channel_4;
  UARTSetup_DMA_Init.DMA_Memory0BaseAddr = (uint32_t)UART1_Tx_Buffer;
  UARTSetup_DMA_Init.DMA_DIR = DMA_DIR_MemoryToPeripheral;
  UARTSetup_DMA_Init.DMA_BufferSize = (uint16_t)UTX1_BUFFER_SIZE;
  UARTSetup_DMA_Init.DMA_Mode = DMA_Mode_Normal;
  UARTSetup_DMA_Init.DMA_Priority = DMA_Priority_High;

  /* Init Tx state */
  UARTSetup_Tx_State = txIdle;
}

/* ########################################################################
 * Timer
 * ########################################################################
 */

/* Low precision non-Blocking delay timer.
 ** Relolution of timer is one TICK step interrupt.
 */
void SysTimer_Start(SYS_TIMER_STRUCT* timer, uint32_t ms)
{
  /* Calculate amount of tick count */
  timer->length = (uint32_t)((float)ms/(1000*SYS_TICKSTEP));

  /* Capture current tick */
  timer->start = (uint32_t)systick_count;
}

int SysTimer_IsTimeout(SYS_TIMER_STRUCT* timer)
{
  uint32_t Capture;

  /* Capture current tick */
  Capture = (uint32_t)systick_count;

  /* Check */
  if (Capture >= timer->start) {
    if ((Capture - timer->start) >= timer->length)
      return 1;
  } else {
    if (((0xFFFFFFFF - timer->start)+Capture) >= timer->length)
      return 1;
  }

  return 0;
}

/* Improved precision non-Blocking delay timer.
 ** Relolution of timer is 1uS.
 */
void SysTimer_uS_Start(SYS_TIMER_uS_STRUCT *timer, uint32_t us)
{
  /* Tick */
  timer->tick = SYS_CURRENT_TICK;

  /* Tick overflow count */
  timer->tid = (uint32_t)systick_count;

  /* Target */
  timer->target_us = us*((uint32_t)HCLK/1000000);
}

int SysTimer_uS_IsTimeout(SYS_TIMER_uS_STRUCT* timer)
{
  uint32_t curr_tick;
  uint32_t curr_tid;

  /* Already timeout ? */
  if (timer->target_us == 0) {
    return 1;
  }

  /* Capture current tick */
  curr_tick = SYS_CURRENT_TICK;
  curr_tid = systick_count;

  /* Processing TID*/
  while (timer->tid != curr_tid) {
    if (timer->target_us > timer->tick) {
      timer->target_us -= timer->tick;
      timer->tid ++;
      timer->tick = SYSTICKRELOADVALUE-1;
    } else {
      timer->target_us = 0;
      return 1;                        /* Timeout */
    }
  }

  /* Processing Tick */
  if ((timer->tick > curr_tick) && ((timer->tick - curr_tick) > timer->target_us))
  {
    timer->target_us = 0;
    return 1;                          /* Timeout */
  }

  /* Need wait */
  return 0;
}

/* Blocking delay, uS */
void SysTimer_delay_us(uint32_t us)
{
  SYS_TIMER_uS_STRUCT timer;
  SysTimer_uS_Start(&timer, us);
  while (SysTimer_uS_IsTimeout(&timer) == 0) ;
}

/* Blocking delay, mS */
void SysTimer_delay_ms(uint32_t ms)
{
  SYS_TIMER_STRUCT timer;
  SysTimer_Start(&timer, ms);
  while (SysTimer_IsTimeout(&timer) == 0) ;
}

/* [EOF] */
